﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using NUnit.Framework;

namespace Workspace
{
    public class Calculator
    {
        public Func<int, int, int> CustomOp { get; set; }
        public Action<int> PrintAction { get; set; }
        public Action PrintHeaderAction { get; set; }

        private int ReallyDoTheWork(int x, int y, Func<int, int, int> theThing )
        {
            var result = theThing(x, y);
            PrintHeaderAction();
            PrintAction(result);
            return result;
        }

        public int Add(int x, int y)
        {
            return ReallyDoTheWork(x, y, (i, i1) => i + i1);
        }

        public int Subtract(int x, int y)
        {
            return ReallyDoTheWork(x, y, (i, i1) => i - i1);
        }

        public int DoCustomOperation(int x, int y)
        {
            return ReallyDoTheWork(x, y, (i, i1) => CustomOp(i, i1));
        }
    }


    [TestFixture]
    public class WorkingWithTheCalculator
    {
        [Test]
        public void Exercising()
        {
            var calculator = new Calculator();
            calculator.PrintAction = x => Debug.WriteLine(string.Format("The Result is:{0}", x));
            calculator.PrintHeaderAction = () => Debug.WriteLine("---------");

            var result = calculator.Add(1, 2);
            Assert.That(result, Is.EqualTo(3));


            calculator.CustomOp = (x, y) => x * y;
            var result2 = calculator.DoCustomOperation(2, 3);
            Assert.That(result2, Is.EqualTo(6));

        }
    }
}
